// xcode.C (formerly auto2unix.cc)
// This program tries to determine input document encoding
// and to convert it to koi8, CP-1251 or cp866.

// Written  by Andrey V. Lukyanov on May 14, 1997
// Last modified on May 18, 1997

// Updated to convert to /don't kill me/ cp1251 (oh, god! I hate it!)
// instead of KOI-8 (original)
// by Cyril Rotmistrovsky
// Updated to make conversions to cp1251, cp866 and koi8-r (default)
// depending on flags
// by Cyril Rotmistrovsky
// Modified on Oct 19, 1997
// Modified by Cyril Rotmistrovsky to be compiled by Watcom C++ 10.0
// (Oh, God! what a non-standard compiler!)
// Last modified on Jun 18 1998

// Modified by Igor V. Krassikov (KIV without Co)
// for quoted-printable decodeing

// Name changed to xcode 


#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#ifndef KOI8_WIN
#define KOI8_WIN \
 "\x5f\x5f\x27\x5f\x22\x3a\x8a\xbc" \
 "\x5f\x25\x5f\x3c\x5f\x5f\x5f\x5f" \
 "\x5f\x27\x27\x22\x22\x07\x2d\x2d" \
 "\x5f\x54\x5f\x3e\x5f\x5f\x5f\x5f" \
 "\x9a\x5f\x5f\x5f\x9d\xbd\x81\x5f" \
 "\xb3\x63\xb4\x3c\x83\x2d\x52\xb7" \
 "\xb7\x2b\xb6\xa6\xad\xde\x14\x9e" \
 "\xa3\xbf\xa4\x3e\x5f\x5f\x5f\xa7" \
 "\xe1\xe2\xf7\xe7\xe4\xe5\xf6\xfa" \
 "\xe9\xea\xeb\xec\xed\xee\xef\xf0" \
 "\xf2\xf3\xf4\xf5\xe6\xe8\xe3\xfe" \
 "\xfb\xfd\xff\xf9\xf8\xfc\xe0\xf1" \
 "\xc1\xc2\xd7\xc7\xc4\xc5\xd6\xda" \
 "\xc9\xca\xcb\xcc\xcd\xce\xcf\xd0" \
 "\xd2\xd3\xd4\xd5\xc6\xc8\xc3\xde" \
 "\xdb\xdd\xdf\xd9\xd8\xdc\xc0\xd1"
#endif
#ifndef KOI8_ALT
#define KOI8_ALT \
 "\xc4\xb3\xda\xbf\xc0\xd9\xc3\xb4" \
 "\xc2\xc1\xc5\xdf\xdc\xdb\xdd\xde" \
 "\xb0\xb1\xb2\xd1\xfe\xd6\xfb\xd7" \
 "\xb7\xb8\xff\xd2\xb6\xfd\xfa\xbd" \
 "\xcd\xba\xd5\xf1\xf5\xc9\xf7\xf9" \
 "\xbb\xd4\xd3\xc8\xbe\xf3\xbc\xc6" \
 "\xc7\xcc\xb5\xf0\xf4\xb9\xf6\xf8" \
 "\xcb\xcf\xd0\xca\xd8\xf2\xce\xfc" \
 "\xee\xa0\xa1\xe6\xa4\xa5\xe4\xa3" \
 "\xe5\xa8\xa9\xaa\xab\xac\xad\xae" \
 "\xaf\xef\xe0\xe1\xe2\xe3\xa6\xa2" \
 "\xec\xeb\xa7\xe8\xed\xe9\xe7\xea" \
 "\x9e\x80\x81\x96\x84\x85\x94\x83" \
 "\x95\x88\x89\x8a\x8b\x8c\x8d\x8e" \
 "\x8f\x9f\x90\x91\x92\x93\x86\x82" \
 "\x9c\x9b\x87\x98\x9d\x99\x97\x9a"
#endif

#define NUMCOD 5

unsigned char* destTab[]={
	(unsigned char *)KOI8_ALT,
	(unsigned char *)KOI8_WIN
};

char * help[]={
	"This program tries to determine input document encoding\n",
	"and to convert it to desired one\n",
	"\n",
	"Written by Andrey V. Lukyanov on May 14, 1997  "
	"Last modified on May 18, 1997\n",
	"Updated by Cyril Rotmistrovsky                 "
	"Last modified on Oct 19, 1997\n",
	"Updated by Igor V. Krassikov                   "
	"Last modified on Oct 29, 1998\n",
	"\n",
	"Usage: %s [-h|-H|-?] [-w|-k|-a] [+w|+k|+a|+i|+m] [-q] "
	"[input [output]]\n",
	"-q to disable quoted-pritable decoding\n",
	"-k to set   koi8      output\n",
	"-w to set   cp1251    output\n",
	"-a to set   cp866     output(default)\n",
	"+k to force koi8      input\n",
	"+w to force cp1251    input\n",
	"+a to force cp866     input\n",
	"+i to force iso8859-5 input\n",
	"+m to force mac       input\n",
	0
};

char * encName[]={"koi8","cp866","cp1251","iso8859-5","mac"};

unsigned char recode_table[NUMCOD][128]={
	{   //koi8
	128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
	144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
	160,161,162,163,164,165,166,167,168,169,170,171,172,'-',174,175,
	176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
	192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
	208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
	224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
	240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
	},
	{ //dos
        225,226,247,231,228,229,246,250,233,234,235,236,237,238,239,240,
        242,243,244,245,230,232,227,254,251,253,255,249,248,252,224,241,
        193,194,215,199,196,197,214,218,201,202,203,204,205,206,207,208,
        144,145,146,129,135,178,156,152,153,181,161,168,174,159,172,131,
        132,137,136,134,128,138,175,176,171,165,187,184,177,160,190,185,
        186,147,128,170,169,162,149,151,188,133,130,141,140,142,143,139,
        210,211,212,213,198,200,195,222,219,221,223,217,216,220,192,209,
        179,163,189,173,180,164,182,166,183,167,158,150,191,157,148,154
	},
	{ //win
         95, 95, 39, 95, 34, 58,138,188, 95, 37, 95, 60, 95, 95, 95, 95,
         95, 39, 39, 34, 34,  7, 45, 45, 95, 84, 95, 62, 95, 95, 95, 95,
        154, 95, 95, 95,157,189,129, 95,179, 99,180, 60,131, 45, 82,183,
        183, 43,182,166,173,222, 20,158,163,191,164, 62, 95, 95, 95,167,
        225,226,247,231,228,229,246,250,233,234,235,236,237,238,239,240,
        242,243,244,245,230,232,227,254,251,253,255,249,248,252,224,241,
        193,194,215,199,196,197,214,218,201,202,203,204,205,206,207,208,
        210,211,212,213,198,200,195,222,219,221,223,217,216,220,192,209
	},
	{ //iso
        128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
        144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
        160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
        225,226,247,231,228,229,246,250,233,234,235,236,237,238,239,240,
        242,243,244,245,230,232,227,254,251,253,255,249,248,252,224,241,
        193,194,215,199,196,197,214,218,201,202,203,204,205,206,207,208,
        210,211,212,213,198,200,195,222,219,221,223,217,216,220,192,209,
        176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
	},
	{ //mac
	225,226,247,231,228,229,246,250,233,234,235,236,237,238,239,240,
	242,243,244,245,230,232,227,254,251,253,255,249,248,252,224,241,
	'*',184,'*','*','*','*','*','I','*','*','*','*','*','*','*','*',
	'*',179,177,178,'i','*',199,'J','E','e','I','i','*','*','*','*',
	'j','S','*','*','f','*','*','*','*','*','*','*','*','*','*','s',
	'-','-', 34, 34, 39, 39,'*', 39,'*','*','*','*','N',163,179,209,
	193,194,215,199,196,197,214,218,201,202,203,204,205,206,207,208,
	210,211,212,213,198,200,195,222,219,221,223,217,216,220,192,'*'
	}
};
int letter_frequency[32]=
{
	125,1606,331,65,598,1714,22,356,168,1312,206,636,1050,658,1295,2259,
	544,447,887,1049,1217,572,200,823,398,400,355,168,67,78,285,4
};

// Added by KIV
// Yes, we have Quoted-Printable...
int hasQP = 0;
int chkQP = 1;
inline int getQP(int first, int second)
{
	if (first  > '9') first  = toupper(first)  - 'A' + 1 +'9';
	if (second > '9') second = toupper(second) - 'A' + 1 +'9';
	return (first-'0')*16 + (second-'0');
};

int main(int argc,char ** argv)
{
	int c=0, a=0, c_old, i, j, force=-1;
	int     decide[NUMCOD];
	double  rating[NUMCOD];
	FILE *f,*out=stdout,*in=stdin;
	int enc=0;
	int I=0;

	for(I=1;argc>I&&(*argv[I]=='+'||*argv[I]=='-'||*argv[I]=='/');I++) {
		switch(argv[I][1]) {
		default: HELP:
                case 'h': case 'H': case '?':
			do {
				char * c = argv[0] + strlen(argv[0]);
				while( (c != argv[0]) && (*c != '\\') && 
				       (*c != '/')) c--;
				if (c != argv[0]) c++;
				for(j=0;help[j];j++) printf(help[j],c);
				return 1;
			} while(0);
		case 'k': case 'K': if(*argv[I]=='+')force=0; else enc=0; break;
		case 'a': case 'A': if(*argv[I]=='+')force=1; else enc=1; break;
		case 'w': case 'W': if(*argv[I]=='+')force=2; else enc=2; break;
		case 'i': case 'I': force=3; if(*argv[I]!='+') goto HELP; 
				    break;
		case 'm': case 'M': force=4; if(*argv[I]!='+') goto HELP; 
			break;
		}
        }

	if(I<argc) {
		in=fopen(argv[I++],"rt");
		assert(in!=0);
        }

	for(i=0; i<NUMCOD; i++){ decide[i]=1; rating[i]=0;}

	f=tmpfile();
	if(f==NULL){ perror("\"tmpfile\""); exit(1);}

	while(1) {
		c_old=c;
		c=getc(in);
		if(c=='\r') continue;
		if(c_old=='\r' && c!='\n') fputc('\n',f);
		if(c==EOF) break;

		// Added by KIV
		if (chkQP && (c == '=')) {
			//Maybe, QP?
			int q1 = getc(in);
			if (!isxdigit(q1)) {
				if (hasQP && ((q1 == '\r')||(q1 == '\n'))) {
					q1 = getc(in);
					if ((q1 == '\r')||(q1 == '\n')) 
						continue;
				};
				ungetc(q1,in);
			} else {
				int q2 = getc(in);
				if (!isxdigit(q2)) {
					ungetc(q2,in);
					ungetc(q1,in);
				} else {
					c = getQP(q1,q2);
					hasQP = 1;
				};
			}
		};
		
		if(c>=128)
			for(i=0; i<NUMCOD; i++)
				if(recode_table[i][c-128]>=192)
					rating[i]+=letter_frequency
						[((int)recode_table[i][c-128]-
						  192)%32];
		fputc(c,f);
        }

	for(i=0; i<NUMCOD; i++)
		for(j=0; j<NUMCOD; j++)
			if(i!=j && rating[i]<rating[j]) decide[i]=0;

	for(i=NUMCOD-1; i>=0; i--) if(decide[i]) a=i;

	fprintf(stderr,"Guessed input encoding: %s\n",encName[a]);
	if(force>=0)
		fprintf(stderr,"Forced input encoding: %s\n",encName[a=force]);

	fprintf(stderr,"Output encoding: %s\n",encName[enc]);

	rewind(f);

	if(I<argc) {
		out=fopen(argv[I++],"wt");
		assert(out!=0);
        }

	while(1) {
		c=fgetc(f);
		if(c==EOF) break;
		if(c>=128) c=recode_table[a][c-128];
		if(enc&&c>=128) c=destTab[enc-1][c-128];
		fputc(c,out);
        }
	//for(i=0; i<NUMCOD; i++) printf("\n%d\n", rating[i]);
	return(0);
}
